#include <stdio.h>
#include <string.h>

#define NMAX 1000001

int degin[NMAX], degout[NMAX];
int N, M, i, j;

int main() {
	//freopen("x.txt", "r", stdin);
	int T;
	scanf("%d", &T);
	
	while (T--) {
		scanf("%d %d", &N, &M);
		memset(degin, 0, (N + 1) * sizeof(int));
		memset(degout, 0, (N + 1) * sizeof(int));
		
		while (M--) {
			scanf("%d %d", &i, &j);
			if (i < j) {
				degout[i]++;
				degin[j]++;
			} else {
				degout[j]++;
				degin[i]++;
			}
		}
		
		for (i = 1; i <= N; i++)
			if (degin[i] == 0 && degout[i] == N - i)
				break;
			
		if (i <= N)
			printf("2 %d\n", i);
		else
			printf("1\n");
	}
	
	return 0;
}
