#include <stdio.h>
#include <string.h>

#define NMAX 20111

char c[NMAX];
int N, K, i, pstart, pend, cnt, nmoves;

int main() {
	//freopen("x.txt", "r", stdin);

	int T;
	scanf("%d", &T);
	
	while (T--) {
		scanf("%d %d %s", &N, &K, c);

		if (N == 1) {
			printf("0\n");
			continue;
		}
		
		pstart = pend = -1;
		cnt = 1;
		for (i = 1; i < N; i++) {
			if (c[i] == c[i - 1])
				cnt++;
			else
				cnt = 1;
			if (cnt == K) {
				pend = i;
				pstart = i - K + 1;
			}
		}

		if (pstart < 0)
			printf("-1\n");
		else {
			nmoves = 1;
			
			if (pend < N - 1) {
				cnt = 1;
				for (i = pend + 2; i < N; i++) {
					if (c[i] == c[i - 1]) {
						cnt++;
					} else {
						nmoves += (cnt / K);
						if (cnt % K > 0)
							nmoves++;
						cnt = 1;
					}
				}

				nmoves += (cnt / K);
				if (cnt % K > 0)
					nmoves++;
			}

			if (pstart > 0) {
				cnt = 1;
				for (i = pstart - 2; i >= 0; i--) {
					if (c[i] == c[i + 1]) {
						cnt++;
					} else {
						nmoves += (cnt / K);
						if (cnt % K > 0)
							nmoves++;
						cnt = 1;
					}
				}

				nmoves += (cnt / K);
				if (cnt % K > 0)
					nmoves++;
			}
			
			printf("%d\n", nmoves);
		}
	}
	
	return 0;
}
