#include <stdio.h>
#include <string.h>

#define NMAX 50
#define LMAX 17
#define CMAX 50

char s[NMAX], qset[NMAX], c[NMAX][LMAX][CMAX];
int cmap[128];
int cnt[LMAX][CMAX];
int N, M, q, Q, i, j, p, u, v, ok;

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %d %s", &N, &Q, s);

	for (i = 0; i < N; i++) {
		cmap[s[i]] = i;
	}

	for (i = 0; i < N; i++)
		for (j = 0; j < LMAX; j++)
			scanf("%s", &c[i][j][0]);
	
	for (q = 1; q <= Q; q++) {
		printf("Query %d: ", q);
		memset(cnt, 0, sizeof(cnt));
		scanf("%s", qset);
		M = strlen(qset);

		for (i = 0; i < M; i++) {
			p = cmap[qset[i]];

			for (u = 0; u < 16; u++)
				for (v = 0; v < 43; v++)
					if (c[p][u][v] == '*')
						cnt[u][v]++;
		}

		for (i = 0; i < M; i++) {
			p = cmap[qset[i]];
			ok = 0;
			for (u = 0; u < 16; u++)
				for (v = 0; v < 43; v++)
					if (c[p][u][v] == '*' && cnt[u][v] == 1) {
						ok = 1;
					}
			
			if (ok)
				printf("Y");
			else
				printf("N");
		}
		
		printf("\n");
	}
		
	return 0;
}
