#include <math.h>
#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

#define KMAX 51
#define XMAX 2511

int am[XMAX][KMAX], amy[XMAX][KMAX];
int ym[XMAX][KMAX], yma[XMAX][KMAX];
vector<pair<double, pair<int, int> > > yx;
int N, K, i, j, p, xc, yc, ac, acnext, xcnext, ycnext, xmax, amax;

int main() {
	//freopen("x.txt", "r", stdin);
	int te, T;
	scanf("%d", &T);

	for (te = 1; te <= T; te++) {
		scanf("%d %d", &N, &K);
		yx.clear();
		yx.resize(N);
		xmax = 0;
		for (i = 0; i < N; i++) {
			scanf("%d %d", &yx[i].second.first, &yx[i].second.second);
			xmax += yx[i].second.first;
			yx[i].first = atan2(yx[i].second.second, yx[i].second.first);
		}

		sort(yx.begin(), yx.end());

		for (xc = 0; xc <= xmax; xc++)
			for (j = 0; j <= K; j++)
				am[xc][j] = amy[xc][j] = ym[xc][j] = yma[xc][j] = -1;

		am[0][0] = amy[0][0] = ym[0][0] = yma[0][0] = 0;
			
		for (i = yx.size() - 1; i >= 0; i--)
			for (xc = xmax; xc >= 0; xc--)
				for (j = K - 1; j >= 0; j--) {
					if (am[xc][j] >= 0) {
						yc = amy[xc][j];
						ac = am[xc][j];
						ycnext = yc + yx[i].second.second;
						acnext = ac + yx[i].second.first * (2 * yc + yx[i].second.second);
						xcnext = xc + yx[i].second.first;
						if (acnext > am[xcnext][j + 1] ||
							(acnext == am[xcnext][j + 1] && ycnext > amy[xcnext][j + 1])) {
							am[xcnext][j + 1] = acnext;
							amy[xcnext][j + 1] = ycnext;
						}

						if (ycnext > ym[xcnext][j + 1] ||
							(ycnext == ym[xcnext][j + 1] && acnext > yma[xcnext][j + 1])) {
							yma[xcnext][j + 1] = acnext;
							ym[xcnext][j + 1] = ycnext;
						}
					}

					if (ym[xc][j] >= 0) {
						yc = ym[xc][j];
						ac = yma[xc][j];
						ycnext = yc + yx[i].second.second;
						acnext = ac + yx[i].second.first * (2 * yc + yx[i].second.second);
						xcnext = xc + yx[i].second.first;
						if (acnext > am[xcnext][j + 1] ||
							(acnext == am[xcnext][j + 1] && ycnext > amy[xcnext][j + 1])) {
							am[xcnext][j + 1] = acnext;
							amy[xcnext][j + 1] = ycnext;
						}

						if (ycnext > ym[xcnext][j + 1] ||
							(ycnext == ym[xcnext][j + 1] && acnext > yma[xcnext][j + 1])) {
							yma[xcnext][j + 1] = acnext;
							ym[xcnext][j + 1] = ycnext;
						}
					}
				}

		amax = 0;
		for (xc = 0; xc <= xmax; xc++)
			if (am[xc][K] > amax) {
				amax = am[xc][K];
			}

		printf("Case %d: %d\n", te, amax);
	}
	
	return 0;
}
