Program Comoara;
const MAXN = 5000;
      MAXXY = 10000;
type TLingou = record
                x,y:longint;
               end;
var n:longint;
    L:array[1..MAXN] of TLingou;
    F:array[0..MAXN] of longint;
    D:array[1..3] of longint;

procedure Aseaza(const i1,i2: longint);
var aux: longint;
begin
  if D[i1] > D[i2] then
    begin
      aux := D[i1];
      D[i1] := D[i2];
      D[i2] := aux;
    end;
end; { Aseaza }

procedure Citeste;
var fin: text;
    i: longint;
begin
  assign(fin, 'COMOARA.IN');
  reset(fin);
  readln(fin, n);
  for i := 1 to n do
    begin
      readln(fin, D[1], D[2], D[3]);

      {Sortarea dimensiunilor si memorarea primelor doua}
      Aseaza(1, 2);
      Aseaza(2, 3);
      Aseaza(1, 2);
      L[i].x := D[1];
      L[i].y := D[2];
    end;
  close(fin);
end; { Citeste }

Function MaiMic(const i,j : longint) : boolean;
begin
  if (L[i].x <> L[j].x)
     then MaiMic := L[i].x < L[j].x
     else MaiMic := L[i].y < L[j].y;
end; { MaiMic }

Procedure BubbleSort;
var i:longint;
    aux:TLingou;
    ok:boolean;
begin
  ok := true;
  while ok do
    begin
      ok := false;
      for i:=1 to n - 1 do
        if MaiMic(i + 1, i) then
          begin
            aux := L[i];
            L[i] := L[i+1];
            L[i+1] := aux;
            ok := true;
          end;
    end;
end; { BubbleSort }

Procedure Filtreaza;
var i,j: longint;
begin
j := 1;
for i := 2 to n do
  begin
    while (j > 0) and (L[j].x <= L[i].x) and
      (L[j].y <= L[i].y) do
        j := j-1;
    j := j + 1;
    L[j] := L[i];
  end;
  n := j;
end; { Filtreaza }

Procedure MetodaPD;
var i,j, min, cost: longint;
begin
  F[0] := 0;
  for i := 1 to n do
    begin
      min := MAXXY * MAXXY + 1;
      for j := 1 to i do
        begin
          cost := F[j - 1] + L[j].y * L[i].x;
          if (cost < min) then min := cost;
        end;
      F[i] := min;
    end;
end; { MetodaPD }

procedure Scrie;
var fout : text;
begin
  assign(fout, 'COMOARA.OUT');
  rewrite(fout);
  writeln(fout, F[n]);
  close(fout);
end;{ Scrie }

begin
  Citeste;
  BubbleSort;
  Filtreaza;
  MetodaPD;
  Scrie;
end.
