#include<fstream>
using namespace std;

bool posLibere[1002][1002], posSigure[1002][1002];
int dameX[101],dameY[101];
int n,m,s,nd,np;
int varX[9] = {-2,0,1,1,1,0,-1,-1,-1};//variatia lui x pe fiecare din directiile 1-8
int varY[9] = {-2,1,1,0,-1,-1,-1,0,1};//variatia lui y pe directii

void initMatrici() {
	for(int i=1; i<=n; i++) {
		for(int j=1; j<=m; j++) {
			posLibere[i][j] = true;
			posSigure[i][j] = true;
		}
	}
	//completam marginile lui posLibere cu false 
	//pt a evita cazuri particulare la comparare
	for(int i=0; i<=n+1; i++) {
		posLibere[i][0] = false;
		posLibere[i][m+1] = false;
	}
	for(int i=0; i<=m+1; i++) {
		posLibere[0][i] = false;
		posLibere[n+1][i] = false;
	}
}

void citire() {
	ifstream fin("DAME.IN");
	fin >> n >> m;
	initMatrici();
	fin >> nd;
	for(int i=1; i<=nd; i++) {
		int x, y;
		fin >> x >> y;
		dameX[i] = x;
		dameY[i] = y;
		posLibere[x][y] = false;
		posSigure[x][y] = false;
	}
	fin >> np;
	for(int i=1; i<=np; i++) {
		int x,y;
		fin >> x >> y;
		posLibere[x][y] = false;
		posSigure[x][y] = false;
	}
	fin.close();
}

void parcurgeDamele() {
	int maxDist = n+m;//o marime >= lungimea maxima a unei linii pe tabla
	for(int i=1; i<=nd; i++) {
		int x = dameX[i];
		int y = dameY[i];
		for (int dir=1; dir<=8; dir++) {
			for(int dist=1; dist<=n+m; dist++) {
				int px = x + varX[dir]*dist;
				int py = y + varY[dir]*dist;
				if(!posLibere[px][py]) {
					break;
				}
				posSigure[px][py] = false;
			}
		}
	}
}

void numaraPosSigure() {
	s = 0;
	for(int i=1; i<=n; i++) {
		for(int j=1; j<=m; j++) {
			if(posSigure[i][j]) {
				s++;
			}
		}
	}
}

void scriere() {
	ofstream fout("DAME.OUT");
	fout << s << endl;
	fout.close();
}

int main() {
	citire();
	parcurgeDamele();
	numaraPosSigure();
	scriere();
	return 0;
}