#include <iostream>
#include <stdio.h>
#include <math.h>
#include <set>
#include <cstdlib>
#include <string.h>
#include <map>
#include <vector>

using namespace std;

void sol();

int main() {
    sol();
    return 0;
}

#define N 50000
#define ull unsigned long long

struct P {
    ull x;
    ull y;
    double dista;
    double distb;
};

int cases, n;
ull c1x;
ull c1y;
ull c2x;
ull c2y;

P pp[N];

struct classa {

    bool operator() (const int& lhs, const int& rhs) const {
        return pp[lhs].dista < pp[rhs].dista;
    }
};

struct classb {

    bool operator() (const int& lhs, const int& rhs) const {
        return pp[lhs].distb < pp[rhs].distb;
    }
};

void sol() {
	FILE *f=fopen("radare.in","r");
        fscanf(f,"%d", &n);
        for (int i = 0; i < n; i++) {
            ull x; ull y;
            fscanf(f,"%llu %llu", &x, &y);
            pp[i].x=x;
            pp[i].y=y;
        }
        fscanf(f,"%llu %llu", &c1x, &c1y);
        fscanf(f,"%llu %llu", &c2x, &c2y);

        for (int i = 0; i < n; i++) {
            pp[i].dista = sqrt(0. + (c1x - pp[i].x)*(c1x - pp[i].x) + (c1y - pp[i].y)*(c1y - pp[i].y));
            pp[i].distb = sqrt(0. + (c2x - pp[i].x)*(c2x - pp[i].x) + (c2y - pp[i].y)*(c2y - pp[i].y));
        }

        set<int, classa> seta;
        set<int, classb> setb;
        for (int i = 0; i < n; i++) {
            seta.insert(i);
            setb.insert(i);
        }

        double mn = min(pp[*seta.rbegin()].dista, pp[*setb.rbegin()].distb);

        for (set<int, classa>::iterator it=seta.begin(); it!=seta.end(); it++) {
            int next = *it;
            setb.erase(next);
            mn = min(mn, pp[*it].dista + (setb.empty() ? 0 : pp[*setb.rbegin()].distb));
        }
		FILE *g=fopen("radare.out","w");
        fprintf(g,"%.6lf\n", mn);
		fclose(g);
    
}

