#include <stdio.h>
#include <string.h>

#define NMAX 111

struct Poly {
	int deg;
	double coef[NMAX];
};

struct Poly polystk[NMAX];
char s[NMAX];
char opstk[NMAX];
int N, i, p, q, niv;
double answer;

int main() {
	//freopen("x.txt", "r", stdin);
	int T;
	
	scanf("%d", &T);
	while (T--) {
		scanf("%s", s);
		N = strlen(s);
		niv = 0;

		for (i = 0; i < N; i++) {
			if (s[i] == 'm' || s[i] == 'M') {
				niv++;
				opstk[niv] = s[i];
			} else {
				niv++;
				opstk[niv] = 'x';
				polystk[niv].deg = 1;
				polystk[niv].coef[0] = 0.0;
				polystk[niv].coef[1] = 1.0;
				
				while (niv >= 3 && opstk[niv] == 'x' && opstk[niv - 1] == 'x') {
					if (opstk[niv - 2] == 'm') {
						polystk[niv - 2].deg = polystk[niv].deg + polystk[niv - 1].deg;
						for (p = 0; p <= polystk[niv - 2].deg; p++)
							polystk[niv - 2].coef[p] = 0.0;
						for (p = 0; p <= polystk[niv].deg; p++)
							polystk[niv].coef[p] = -polystk[niv].coef[p];
						polystk[niv].coef[0] += 1.0;

						for (p = 0; p <= polystk[niv - 1].deg; p++)
							polystk[niv - 1].coef[p] = -polystk[niv - 1].coef[p];
						polystk[niv - 1].coef[0] += 1.0;

						for (p = 0; p <= polystk[niv].deg; p++)
							for (q = 0; q <= polystk[niv - 1].deg; q++)
								polystk[niv - 2].coef[p + q] += polystk[niv].coef[p] * polystk[niv - 1].coef[q];

						for (p = 0; p <= polystk[niv - 2].deg; p++)
							polystk[niv - 2].coef[p] = -polystk[niv - 2].coef[p];
						polystk[niv - 2].coef[0] += 1.0;
					} else { // opstk[niv - 2] == 'M'
						polystk[niv - 2].deg = polystk[niv].deg + polystk[niv - 1].deg;
						for (p = 0; p <= polystk[niv - 2].deg; p++)
							polystk[niv - 2].coef[p] = 0.0;
						for (p = 0; p <= polystk[niv].deg; p++)
							for (q = 0; q <= polystk[niv - 1].deg; q++)
								polystk[niv - 2].coef[p + q] += polystk[niv].coef[p] * polystk[niv - 1].coef[q];
					}
					
					niv -= 2;
					opstk[niv] = 'x';
				}
			}
		}
		
		/*
		fprintf(stderr, "niv=%d deg=%d\n", niv, polystk[niv].deg);
		for (i = 0; i <= polystk[niv].deg; i++)
			fprintf(stderr, " %lf", polystk[niv].coef[i]);
		fprintf(stderr, "\n");
		*/
		
		answer = 1.0;
		for (i = 1; i <= polystk[niv].deg; i++)
			answer -= polystk[niv].coef[i] / (i + 1);

		printf("%.9lf\n", answer);
	}
	
	return 0;
}
