#include <iostream>
#include <stdio.h>
#include <math.h>
#include <stack>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string.h>
#include <map>

using namespace std;


#define INF 1000000
#define N 100
int n, m, k;
int G[N+1][N+1];
int pos[N+1], val[N+1];
int hit[N+1];
int tt=0;

void back(int from, int time, int sum) {
    if(val[from]-time>0) sum+= val[from] - time;
    tt=max(tt, sum);
    for (int i = 1; i <= k; i++) {
        if (hit[i] == 0 && G[pos[from]][pos[i]] != INF) {
            hit[i] = 1;
            back(i, time + G[pos[from]][pos[i]], sum);
            hit[i] = 0;
        }
    }
}

void sol() {
	FILE *f=fopen("comori.in","r");
    int cases;
        fscanf(f,"%d %d %d", &n, &m, &k);

        for (int i = 0; i <= n; i++) {
            for (int j = 0; j <= n; j++) {
                G[i][j] = (i == j) ? 0 : INF;
            }
        }
        for (int i = 0; i < m; i++) {
            int a, b, v;
            fscanf(f,"%d %d %d", &a, &b, &v);
            G[a][b] = v;
            G[b][a] = v;
        }
        for (int i = 0; i <= 10; i++) {
            val[i] = 0;
            pos[i] = 0;
        }

        for (int i = 1; i <= k; i++) {
            int c, v;
            fscanf(f,"%d %d", &c, &v);
            pos[i] = c;
            val[i] = v;
        }

        for (int kk = 1; kk <= n; kk++) {
            for (int i = 1; i <= n; i++) {
                for (int j = 1; j <= n; j++) {
                    G[i][j] = min(G[i][j], G[i][kk] + G[kk][j]);
                }
            }
        }
        tt=0;
        for (int i = 1; i <= k; i++) {
            if (G[1][pos[i]] != INF) {
                memset(hit, N, sizeof (int));
                hit[i] = 1;
                back(i, 0, 0);
                hit[i] = 0;
            }
        }
		FILE *g=fopen("comori.out","w");
        fprintf(g,"%d\n", tt);
		fclose(g);
    
}

int main() {
    sol();
    return 0;
}

