#include<stdio.h>
#include<stdlib.h>

int mat[21][11],k,m,nr_elem,st[21],final[21],max=0;

void sort(int p, int q) //sortare linie k din matricea mat
{
	int m;
	if (p<q)
	{
		int st=p,dr=q,ps=0,pd=1;
		while (st<dr)
		{
			if (mat[k][st]<mat[k][dr])
			{
				int aux=mat[k][st];
				mat[k][st]=mat[k][dr];
				mat[k][dr]=aux;
				aux=ps;
				ps=pd;
				pd=aux;
			}
			st+=ps;
			dr-=pd;
		}
		m=st;
		sort(p,m-1);
		sort(m+1,q);
	}
}

void schimb_lin(int x, int y) //interschimbare de linii din matricea mat
{
	int i;
	for(i=0;i<=nr_elem;i++)
	{
		int aux=mat[x][i];
		mat[x][i]=mat[y][i];
		mat[y][i]=aux;
	}
}

void sec_sort(int p, int q) //sortare linii dupa elementele de pe coloana k
{
	int m;
	if (p<q)
	{
		int st=p,dr=q,ps=0,pd=1;
		while (st<dr)
		{
			if (mat[st][k]<mat[dr][k])
			{
				int aux=ps;
				ps=pd;
				pd=aux;
				schimb_lin(st,dr);
			}
			st+=ps;
			dr-=pd;
		}
		m=st;
		sec_sort(p,m-1);
		sec_sort(m+1,q);
	}
}


void aranjare(int st, int dr,int lvl) //sortare lexicografica a matricii, lvl fiind nivelul de adancime in matrice (coloana dupa care se face sortarea intermediara)
{
	int i=st,j=st;
	while (i<dr&&j<=dr)
		if (mat[j][lvl]==mat[j+1][lvl])
			j++;
		else
			if (i<j)
			{
				k=lvl+1;
				sec_sort(i,j);
				aranjare(i,j,lvl+1);
				j++;
				i=j;
			}
			else
			{
				j++;
				i=j;
			}
}




void bt(int k) //bt de gasire a celei mai lungi secvente de cutii imbricate (Aranjamente) cu particularitatea data de sortarile anterioare: toate numerele din stiva sunt in ordine crescatoare
{
	for(st[k]=st[k-1]+1;st[k]<=m;st[k]++)
		if ((m-st[1]+1)>=max)
		{
			int i=1,ok=1;
			if (k>1)
			while(i<=nr_elem&&ok)
				if (mat[st[k]][i]>mat[st[k-1]][i])
					ok=0;
				else
					i++;
			if (ok)
			{
				if (k>max)
				{
					for(i=1;i<=k;i++)
						final[i]=st[i];
					max=k;
				}
					
				bt(k+1);
			}
		}
}

int main()
{
	
	int i,j;
	FILE *fin=fopen("cutii.in","r");
	fscanf(fin,"%d %d",&m,&nr_elem);
	
	for (i=1;i<=m;i++)
	{
		for(j=1;j<=nr_elem;j++)
			fscanf(fin,"%d",&mat[i][j]);
		mat[i][0]=i;
		k=i;
		sort(1,nr_elem);
	}
	

	k=1;
	sec_sort(1,m);

	
	aranjare(1,m,1);	

	bt(1);
	FILE *fout=fopen("cutii.out","w");
	fprintf(fout,"%d\n",max);
	for (i=max;i>=1;i--)
	{
		fprintf(fout,"%d ",mat[final[i]][0]);
	}
	fclose(fout);
	fclose(fin);
	
	return 0;
}
