#include<fstream>
using namespace std;

const int MAX_VIATA = 100;

int viata[2][20101];//viata maxima pt monstrul curent si cel precedent, 
//pt toate numerele de vraji
int vd[20001], vp[20001];
int *vPrec, *vCur;
int n, m, minVraji;

void citire() {
	ifstream fin("joc.IN");
	fin >> n;
	for (int i=1; i<=n; i++) {
		fin >> vd[i] >> vp[i];
	}
	fin.close();
}

int min(int a, int b) {
	return a < b ? a : b;
}

int max(int a, int b) {
	return a > b ? a : b;
}

void calculVraji() {
	vPrec = viata[0];
	vCur = viata[1];
	//init vPrec	
	for(int i=0; i<=n; i++) {
		vPrec[i] = 0;
		vCur[i] = 0;
	}
	vPrec[0] = MAX_VIATA;//initial avem 100 viata, 0 vraji consumate
	//bucla pt monstrul i
	minVraji = 0;
	for(int iMons=1; iMons<=n; iMons++) {
		for(int iVraja=minVraji; iVraja <= minVraji + MAX_VIATA; iVraja++) {//bucla pt vraja j
			int vSabie = 0;
			int vVraja = 0;
			if (vPrec[iVraja] > 0) { //varianta sabie
				int vInc = min(vPrec[iVraja] + vd[iMons], MAX_VIATA );
				vSabie = max(vInc - vp[iMons], 0);
			}
			if (iVraja >= 1 && vPrec[iVraja - 1] > 0) { //varianta vraja
				int vInc = min(vPrec[iVraja - 1] + vd[iMons], MAX_VIATA);
				vVraja = vInc;
			}
			vCur[iVraja] = max(vSabie, vVraja);
		}
		if (vCur[minVraji] == 0) {
			vPrec[minVraji] = 0;
			minVraji++;
		}
		//inversam vPrec si vCur
		int *aux = vCur;
		vCur = vPrec;
		vPrec = aux;
	}
	//cautam numarul minim de vraji pt care viata > 0
	m = minVraji;
}

void scriere() {
	ofstream fout("joc.OUT");
	fout << m;
	fout.close();
}

int main() {
	citire();
	calculVraji();
	scriere();
	return 0;
}



